// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
int timer0_touch_cnt = 0;					// timer0 ġ  10ms ī

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// PortA 
// LCD_D[0..7] : LCD Data Bus
	PORTA=0xff;						// Ʈ  reg             
	DDRA=0x00;                                              // Ʈ  reg(0Է,1)

// PortC 
// LCD_D[8..15] : LCD Data Bus(color lcd)
// PortC.0 : LCD_CS1
// PortC.1 : LCD_CS2
	PORTC=0xfc;						// Ʈ  reg             
	DDRC=0x03;                                              // Ʈ  reg(0Է,1)

// PortE 
// PortE.3(OUT) : LCD DIR
// PortE.4(OUT) : LCD E
// PortE.5(OUT) : LCD RS
// PortE.6(OUT) : GLCD/CLCD Reset
// PortE.7(IN)  : TSC2003 Interrupt PULL UP(external) 
	PORTE=0x40;						// Ʈ  reg             
	DDRE=0x78;                                              // Ʈ  reg(0Է,1)

// PortG 
// PortG.0(OUT) : LCD R/W,CLCD_WR
// PortG.1(OUT) : LCD RD
// PortG.2(OUT) : LCD CS
	PORTG=0x07;						// Ʈ  reg             
	DDRG=0x07;                                              // Ʈ  reg(0Է,1)
	ASSR=0x00;

// Timer/Counter0 
	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99	
	OCR0=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	ETIMSK=0x00;

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x33;

// External SRAM page configuration: 
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): 1r/w
//	MCUCR=0xc0;
//	XMCRA=0x02;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

	fdevopen(putchar_0,getchar_0,0);
// Global enable interrupts
	sei();
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_UART0_RECV)
{
char status,data;

	status=UCSR0A;
	data=UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

}

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW0)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_touch_cnt++;					// Ÿ̸0 ġ  ī++
}

// ============================== COM1 1Ʈ ۽ =========================
// [μ] char data
// item1:  
// --------------------------------------------------------------------------
int putchar_0(char data)
{
	if(data == '\n'){
		while((UCSR0A & DATA_REGISTER_EMPTY) == 0);
		UDR0 = '\r';
	}
	while((UCSR0A & DATA_REGISTER_EMPTY) == 0);
	UDR0 = data;
	return(0);
}

// ============================== COM1 1Ʈ  =========================
// [μ] void
// []  
// --------------------------------------------------------------------------
int getchar_0(void)
{
	while((UCSR0A & RX_COMPLETE) == 0);
	return(UDR0);
}
