
;CodeVisionAVR C Compiler V1.25.3 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Medium
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : No
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __GETBRPF
	OUT  RAMPZ,R22
	ELPM R@0,Z
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test.vec"
	.INCLUDE "test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
	LDI  R29,BYTE3(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	OUT  RAMPZ,R29
	ELPM R24,Z+
	ELPM R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	ELPM R26,Z+
	ELPM R27,Z+
	ELPM R0,Z+
	ELPM R1,Z+
	ELPM R28,Z+
	ELPM R29,Z+
	MOVW R22,R30
	IN   R29,RAMPZ
	MOVW R30,R0
	OUT  RAMPZ,R28
__GLOBAL_INI_LOOP:
	ELPM R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500
;       1 // ======================= Atmega128 ؽƮ Touch α׷ ====================
;       2 //  CPU : ATmega128-16M - ؽƮ TSC2003(ġ Ʈѷ)
;       3 //     ¥ : 2006-
;       4 //      : Ver1.0
;       5 //    : www.cpuplaza.com
;       6 // Ϸ : CodeVisionAVR
;       7 //      : serial 19200,N,8,1
;       8 // ----------------------------------------------------------------------------
;       9 // ⺻ 
;      10 #include <mega128.h>						// CPU  
;      11 
;      12 #include <stdio.h>
;      13 #include <stdlib.h>
;      14 #include <ctype.h>
;      15 #include <float.h>
;      16 #include <math.h>
;      17 #include <delay.h>
;      18 
;      19 // Լ 
;      20 void main_menu_disp(void);						//  ޴ ǥ
;      21 int Touch_Data(int scan_time);						// ġ  
;      22 void TSC2003_Setup(void);						// I2c ʱȭ TSC2003ʱȭ
;      23 void TSC2003_Write(unsigned char  byte);				// TSC2003 ġ Write
;      24 unsigned TSC2003_Word_Read(unsigned char cmd);				// TSC2003 ġ Word Read
;      25 
;      26 //  
;      27 #include "cpusetup.inc"							// cpu  ͷƮ  ƾ
;      28 // =================================== CPUʱȭ ͷƮ ===================
;      29 //      : CPU  ϰ ͷƮ  ƾ .
;      30 // ----------------------------------------------------------------------------
;      31 //   
;      32 #define RXB8 1
;      33 #define TXB8 0
;      34 #define UPE 2
;      35 #define OVR 3
;      36 #define FE 4
;      37 #define UDRE 5
;      38 #define RXC 7
;      39 
;      40 #define FRAMING_ERROR (1<<FE)
;      41 #define PARITY_ERROR (1<<UPE)
;      42 #define DATA_OVERRUN (1<<OVR)
;      43 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      44 #define RX_COMPLETE (1<<RXC)
;      45 
;      46 // Լ 
;      47 int putchar_0(char data);					// COM1 ۽
;      48 int getchar_0(void);						// COM1 
;      49 
;      50 //  
;      51 char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
;      52 int timer0_touch_cnt = 0;					// timer0 ġ  10ms ī
;      53 
;      54 // ===================================== CPUʱȭ ============================
;      55 // [μ] void
;      56 // ----------------------------------------------------------------------------
;      57 void cpu_setup(void)
;      58 {

	.CSEG
_cpu_setup:
;      59 // PortA 
;      60 // LCD_D[0..7] : LCD Data Bus
;      61 	PORTA=0xff;						// Ʈ  reg
	LDI  R30,LOW(255)
	OUT  0x1B,R30
;      62 	DDRA=0x00;                                              // Ʈ  reg(0Է,1)
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;      63 
;      64 // PortC 
;      65 // LCD_D[8..15] : LCD Data Bus(color lcd)
;      66 // PortC.0 : LCD_CS1
;      67 // PortC.1 : LCD_CS2
;      68 	PORTC=0xfc;						// Ʈ  reg
	LDI  R30,LOW(252)
	OUT  0x15,R30
;      69 	DDRC=0x03;                                              // Ʈ  reg(0Է,1)
	LDI  R30,LOW(3)
	OUT  0x14,R30
;      70 
;      71 // PortE 
;      72 // PortE.3(OUT) : LCD DIR
;      73 // PortE.4(OUT) : LCD E
;      74 // PortE.5(OUT) : LCD RS
;      75 // PortE.6(OUT) : GLCD/CLCD Reset
;      76 // PortE.7(IN)  : TSC2003 Interrupt PULL UP(external)
;      77 	PORTE=0x40;						// Ʈ  reg
	LDI  R30,LOW(64)
	OUT  0x3,R30
;      78 	DDRE=0x78;                                              // Ʈ  reg(0Է,1)
	LDI  R30,LOW(120)
	OUT  0x2,R30
;      79 
;      80 // PortG 
;      81 // PortG.0(OUT) : LCD R/W,CLCD_WR
;      82 // PortG.1(OUT) : LCD RD
;      83 // PortG.2(OUT) : LCD CS
;      84 	PORTG=0x07;						// Ʈ  reg
	LDI  R30,LOW(7)
	STS  101,R30
;      85 	DDRG=0x07;                                              // Ʈ  reg(0Է,1)
	STS  100,R30
;      86 
;      87 // Timer/Counter0 
;      88 	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	OUT  0x33,R30
;      89 	TCNT0 = 99;						// 255-156 = 99
	LDI  R30,LOW(99)
	OUT  0x32,R30
;      90 	OCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x31,R30
;      91 
;      92 // Timer(s)/Counter(s) Interrupt(s) 
;      93 	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	IN   R30,0x37
	ORI  R30,1
	OUT  0x37,R30
;      94 	ETIMSK=0x00;
	LDI  R30,LOW(0)
	STS  125,R30
;      95 
;      96 //  ʱȭ(COM1)
;      97 // 19200Bps, 8Data, 1 Stop, No Parity
;      98 	UCSR0A=0x00;
	OUT  0xB,R30
;      99 	UCSR0B=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;     100 	UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  149,R30
;     101 	UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
;     102 	UBRR0L=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
;     103 
;     104 // External SRAM page configuration:
;     105 //              -              / 0000h - FFFFh
;     106 // Lower page wait state(s): None
;     107 // Upper page wait state(s): 1r/w
;     108 //	MCUCR=0xc0;
;     109 //	XMCRA=0x02;
;     110 
;     111 // Analog Comparator 
;     112 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     113 	SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     114 
;     115 // Global enable interrupts
;     116 #asm("sei")
	sei
;     117 }
	RET
;     118 
;     119 // =============================== COM1 ͷƮ ===========================
;     120 // [μ] void
;     121 // ----------------------------------------------------------------------------
;     122 #pragma savereg-
;     123 interrupt [USART0_RXC] void uart0_rx_isr(void)
;     124 {
_uart0_rx_isr:
;     125 char status,data;
;     126 #asm
;     127 	push r26
	push r26
;     128 	push r27
	push r27
;     129 	push r30
	push r30
;     130 	push r31
	push r31
;     131 	in   r26,sreg
	in   r26,sreg
;     132 	push r26
	push r26
;     133 #endasm
;     134 
;     135 	status=UCSR0A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
;     136 	data=UDR0;
	IN   R16,12
;     137 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     138 		com1_rx_data = data;
	MOV  R5,R16
;     139 		com1_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     140 	}
;     141 
;     142 #asm
_0x3:
;     143 	pop  r26
	pop  r26
;     144 	out  sreg,r26
	out  sreg,r26
;     145 	pop  r31
	pop  r31
;     146 	pop  r30
	pop  r30
;     147 	pop  r27
	pop  r27
;     148 	pop  r26
	pop  r26
;     149 #endasm
;     150 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     151 #pragma savereg+
;     152 
;     153 // ========================== TIMER0 overflow ͷƮ ========================
;     154 // [μ] void
;     155 // [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
;     156 // ----------------------------------------------------------------------------
;     157 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     158 {
_timer0_ovf_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     159 	TCNT0 = 99;						// 255-156 = 100
	LDI  R30,LOW(99)
	OUT  0x32,R30
;     160 	timer0_touch_cnt++;					// Ÿ̸0 ġ  ī++
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
;     161 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     162 
;     163 //  
;     164 int Touch_X = 0,Touch_Y = 0;						// ġ ġ  
;     165 
;     166 // ===============================  α׷ ==============================
;     167 // [μ]: void
;     168 // ---------------------------------------------------------------------------
;     169 int main(void)
;     170 {
_main:
;     171 	cpu_setup();							// cpu ʱȭ
	CALL _cpu_setup
;     172 	TSC2003_Setup();						// I2c ʱȭ TSC2003ʱȭ
	RCALL _TSC2003_Setup
;     173 	main_menu_disp();						//  ޴ ǥ
	RCALL _main_menu_disp
;     174 	while(1){
_0x4:
;     175 		if(com1_rx_eflg){					// COM1  ˻
	TST  R4
	BREQ _0x7
;     176 			putchar(com1_rx_data);
	ST   -Y,R5
	CALL _putchar
;     177 			com1_rx_eflg = 0;
	CLR  R4
;     178 		}
;     179 		if(Touch_Data(2)){					// ġ  ˻ 20ms
_0x7:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Touch_Data
	SBIW R30,0
	BREQ _0x8
;     180 			printf("touch > (x)%d : (y)%d\r\n",Touch_X,Touch_Y);
	__POINTD1FN _0,0
	CALL __PUTPARD1
	MOVW R30,R8
	CALL __CWD1
	CALL __PUTPARD1
	MOVW R30,R10
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R24,8
	CALL _printf
	ADIW R28,12
;     181 		}
;     182 	}
_0x8:
	RJMP _0x4
;     183 	return 0;
_0x9:
	RJMP _0x9
;     184 }
;     185 
;     186 // =====================================  ޴ ǥ =======================
;     187 // [μ] void
;     188 // ---------------------------------------------------------------------------
;     189 void main_menu_disp(void)
;     190 {
_main_menu_disp:
;     191 	printf("\r\n");
	__POINTD1FN _0,21
	CALL SUBOPT_0x0
;     192 	printf("======= TSC2003 Touch Test =======\r\n");
	__POINTD1FN _0,24
	CALL SUBOPT_0x0
;     193 	printf("- press any touch screen         -\r\n");
	__POINTD1FN _0,61
	CALL SUBOPT_0x0
;     194 	printf("----------------------------------\r\n");
	__POINTD1FN _0,98
	CALL SUBOPT_0x0
;     195 }
	RET
;     196 
;     197 // ========================== ġκ ͸  =======================
;     198 // [μ] int scan_time
;     199 // Item1: ġ SCAN Timne(scan_time * 10ms)
;     200 // [] 1( ȿ),0( )
;     201 // [] Touch_X,Touch_Y : ġ  
;     202 // ---------------------------------------------------------------------------
;     203 int Touch_Data(int scan_time)
;     204 {
_Touch_Data:
;     205 	if((PINE&0x80) == 0){						// ġ ?
;	scan_time -> Y+0
	SBIC 0x1,7
	RJMP _0xA
;     206 		if(timer0_touch_cnt >= scan_time){			// ġ  üũ Ÿ scan_time*10ms
	LD   R30,Y
	LDD  R31,Y+1
	CP   R6,R30
	CPC  R7,R31
	BRLT _0xB
;     207 			Touch_X = TSC2003_Word_Read(0xcc);		// X  / 12bit / ADC ON
	LDI  R30,LOW(204)
	ST   -Y,R30
	RCALL _TSC2003_Word_Read
	MOVW R8,R30
;     208 			Touch_Y = TSC2003_Word_Read(0xdc);		// Y  / 12bit / ADC ON
	LDI  R30,LOW(220)
	ST   -Y,R30
	RCALL _TSC2003_Word_Read
	MOVW R10,R30
;     209 			TSC2003_Write(0x38);				// PENIRQ ready mode
	LDI  R30,LOW(56)
	ST   -Y,R30
	RCALL _TSC2003_Write
;     210 			timer0_touch_cnt = 0;				// timer clear
	CLR  R6
	CLR  R7
;     211 			return(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xA0
;     212 		}
;     213 	}
_0xB:
;     214 	else timer0_touch_cnt = 0;					//  
	RJMP _0xC
_0xA:
	CLR  R6
	CLR  R7
;     215 	return(0);
_0xC:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0xA0:
	ADIW R28,2
	RET
;     216 }
;     217 
;     218 // ================================ TSC2003 Setup ============================
;     219 // [μ] void
;     220 // ---------------------------------------------------------------------------
;     221 void TSC2003_Setup(void)
;     222 {
_TSC2003_Setup:
;     223 // TWI(I2c) setup
;     224 	TWBR = 0x0c;							// Bit Rate: 400.000 kHz
	LDI  R30,LOW(12)
	STS  112,R30
;     225 	TWDR = 0xff;							// TWI DATA = 0xff
	LDI  R30,LOW(255)
	STS  115,R30
;     226 	TWSR = 0x00;							//  Clear , prescaler = 00(1)
	LDI  R30,LOW(0)
	STS  113,R30
;     227 
;     228 // TSC2003 setup
;     229 	TSC2003_Write(0x38);						// PENIRQ ready mode
	LDI  R30,LOW(56)
	ST   -Y,R30
	RCALL _TSC2003_Write
;     230 }
	RET
;     231 
;     232 // ================================ TSC2003 Write ============================
;     233 // [μ] unsigned char datau
;     234 // Item1:  
;     235 // ---------------------------------------------------------------------------
;     236 void TSC2003_Write(unsigned char datau)
;     237 {
_TSC2003_Write:
;     238 	TWCR = 0xa4;							// START
;	datau -> Y+0
	LDI  R30,LOW(164)
	STS  116,R30
;     239 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x08));
_0xD:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x10
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x8)
	BREQ _0xF
_0x10:
	RJMP _0xD
_0xF:
;     240 	TWDR = 0x90;							// Address 0 + write
	CALL SUBOPT_0x1
;     241 	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
;     242 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x18));
_0x12:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x15
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x18)
	BREQ _0x14
_0x15:
	RJMP _0x12
_0x14:
;     243 	TWDR = datau;							// data ۽
	LD   R30,Y
	CALL SUBOPT_0x2
;     244 	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
;     245 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x28));
_0x17:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x1A
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x28)
	BREQ _0x19
_0x1A:
	RJMP _0x17
_0x19:
;     246 
;     247 	TWCR = 0x94;							// Ϸ 
	LDI  R30,LOW(148)
	STS  116,R30
;     248 }
	ADIW R28,1
	RET
;     249 
;     250 // =============================== TSC2003 word Read =========================
;     251 // [μ] unsigned char cmd
;     252 // Item1: ġ  command 
;     253 // ---------------------------------------------------------------------------
;     254 unsigned TSC2003_Word_Read(unsigned char cmd)
;     255 {
_TSC2003_Word_Read:
;     256 unsigned char byte;
;     257 unsigned rdatau = 0;
;     258 
;     259 	TWCR = 0xa4;							// START
	CALL __SAVELOCR4
;	cmd -> Y+4
;	byte -> R17
;	rdatau -> R18,R19
	LDI  R18,0
	LDI  R19,0
	LDI  R30,LOW(164)
	STS  116,R30
;     260 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x08));
_0x1C:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x1F
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x8)
	BREQ _0x1E
_0x1F:
	RJMP _0x1C
_0x1E:
;     261 	TWDR = 0x90;							// Address 0 + write
	CALL SUBOPT_0x1
;     262 	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
;     263 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x18));
_0x21:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x24
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x18)
	BREQ _0x23
_0x24:
	RJMP _0x21
_0x23:
;     264 	TWDR = cmd;							// cmd data ۽
	LDD  R30,Y+4
	CALL SUBOPT_0x2
;     265 	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
;     266 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x28));
_0x26:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x29
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x28)
	BREQ _0x28
_0x29:
	RJMP _0x26
_0x28:
;     267 
;     268 	TWCR = 0xa4;							// START
	LDI  R30,LOW(164)
	STS  116,R30
;     269 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x10));	//  ?
_0x2B:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x2E
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x10)
	BREQ _0x2D
_0x2E:
	RJMP _0x2B
_0x2D:
;     270 	TWDR = 0x91;   							// Address 0 + read
	LDI  R30,LOW(145)
	CALL SUBOPT_0x2
;     271 	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
;     272 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x40));	// SLA-R Ϸ?
_0x30:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x33
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x40)
	BREQ _0x32
_0x33:
	RJMP _0x30
_0x32:
;     273 	TWCR = 0xc4;							// data read
	LDI  R30,LOW(196)
	STS  116,R30
;     274 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x50));	// data  ACK?
_0x35:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x38
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x50)
	BREQ _0x37
_0x38:
	RJMP _0x35
_0x37:
;     275 	rdatau = TWDR;
	LDS  R18,115
	CLR  R19
;     276 	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	LDI  R30,LOW(132)
	STS  116,R30
;     277 	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x58));	// data  ACK?
_0x3A:
	LDS  R30,116
	ANDI R30,LOW(0x80)
	BREQ _0x3D
	LDS  R30,113
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x58)
	BREQ _0x3C
_0x3D:
	RJMP _0x3A
_0x3C:
;     278 	byte = TWDR;
	LDS  R17,115
;     279 
;     280 	TWCR = 0x94;							// Ϸ 
	LDI  R30,LOW(148)
	STS  116,R30
;     281 
;     282 	rdatau =  (rdatau << 4) & 0x0ff0;				// D11-D4
	MOVW R30,R18
	CALL __LSLW4
	ANDI R30,LOW(0xFF0)
	ANDI R31,HIGH(0xFF0)
	MOVW R18,R30
;     283 	rdatau |= (unsigned)((byte >> 4) & 0x0f);			// D3-D0
	MOV  R30,R17
	SWAP R30
	ANDI R30,LOW(0xF)
	LDI  R31,0
	__ORWRR 18,19,30,31
;     284 
;     285 	return rdatau;
	MOVW R30,R18
	CALL __LOADLOCR4
	ADIW R28,5
	RET
;     286 }

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x3F
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x41
	__CPWRN 16,17,2
	BRLO _0x42
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x41:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x42:
	RJMP _0x43
_0x3F:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0x43:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,8
	CALL __SAVELOCR6
	LDI  R17,0
_0x44:
	__GETD1S 20
	__SUBD1N -1
	__PUTD1S 20
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	__GETBRPF 30
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x46
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x4A
	CPI  R18,37
	BRNE _0x4B
	LDI  R17,LOW(1)
	RJMP _0x4C
_0x4B:
	CALL SUBOPT_0x3
_0x4C:
	RJMP _0x49
_0x4A:
	CPI  R30,LOW(0x1)
	BRNE _0x4D
	CPI  R18,37
	BRNE _0x4E
	CALL SUBOPT_0x3
	RJMP _0xA1
_0x4E:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x4F
	LDI  R16,LOW(1)
	RJMP _0x49
_0x4F:
	CPI  R18,43
	BRNE _0x50
	LDI  R20,LOW(43)
	RJMP _0x49
_0x50:
	CPI  R18,32
	BRNE _0x51
	LDI  R20,LOW(32)
	RJMP _0x49
_0x51:
	RJMP _0x52
_0x4D:
	CPI  R30,LOW(0x2)
	BRNE _0x53
_0x52:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x54
	ORI  R16,LOW(128)
	RJMP _0x49
_0x54:
	RJMP _0x55
_0x53:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x49
_0x55:
	CPI  R18,48
	BRLO _0x58
	CPI  R18,58
	BRLO _0x59
_0x58:
	RJMP _0x57
_0x59:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x49
_0x57:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x5D
	CALL SUBOPT_0x4
	LD   R30,X
	CALL SUBOPT_0x5
	RJMP _0x5E
_0x5D:
	CPI  R30,LOW(0x73)
	BRNE _0x60
	CALL SUBOPT_0x4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x61
_0x60:
	CPI  R30,LOW(0x70)
	BRNE _0x63
	CALL SUBOPT_0x4
	CALL __GETD1P
	CALL SUBOPT_0x6
	CALL SUBOPT_0x7
	CALL __PUTPARD1
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x61:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x64
_0x63:
	CPI  R30,LOW(0x64)
	BREQ _0x67
	CPI  R30,LOW(0x69)
	BRNE _0x68
_0x67:
	ORI  R16,LOW(4)
	RJMP _0x69
_0x68:
	CPI  R30,LOW(0x75)
	BRNE _0x6A
_0x69:
	__POINTD1FN _tbl10_G2,0
	CALL SUBOPT_0x6
	LDI  R17,LOW(5)
	RJMP _0x6B
_0x6A:
	CPI  R30,LOW(0x58)
	BRNE _0x6D
	ORI  R16,LOW(8)
	RJMP _0x6E
_0x6D:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x9F
_0x6E:
	__POINTD1FN _tbl16_G2,0
	CALL SUBOPT_0x6
	LDI  R17,LOW(4)
_0x6B:
	SBRS R16,2
	RJMP _0x70
	CALL SUBOPT_0x4
	CALL __GETW1P
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,0
	BRGE _0x71
	CALL __ANEGW1
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDI  R20,LOW(45)
_0x71:
	CPI  R20,0
	BREQ _0x72
	SUBI R17,-LOW(1)
	RJMP _0x73
_0x72:
	ANDI R16,LOW(251)
_0x73:
	RJMP _0x74
_0x70:
	CALL SUBOPT_0x4
	CALL __GETW1P
	STD  Y+12,R30
	STD  Y+12+1,R31
_0x74:
_0x64:
	SBRC R16,0
	RJMP _0x75
_0x76:
	CP   R17,R21
	BRSH _0x78
	SBRS R16,7
	RJMP _0x79
	SBRS R16,2
	RJMP _0x7A
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x7B
_0x7A:
	LDI  R18,LOW(48)
_0x7B:
	RJMP _0x7C
_0x79:
	LDI  R18,LOW(32)
_0x7C:
	CALL SUBOPT_0x3
	SUBI R21,LOW(1)
	RJMP _0x76
_0x78:
_0x75:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x7D
_0x7E:
	CPI  R19,0
	BREQ _0x80
	SBRS R16,3
	RJMP _0x81
	CALL SUBOPT_0x7
	__SUBD1N -1
	CALL SUBOPT_0x6
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	__GETBRPF 30
	RJMP _0xA2
_0x81:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xA2:
	ST   -Y,R30
	CALL SUBOPT_0x8
	CPI  R21,0
	BREQ _0x83
	SUBI R21,LOW(1)
_0x83:
	SUBI R19,LOW(1)
	RJMP _0x7E
_0x80:
	RJMP _0x84
_0x7D:
_0x86:
	LDI  R18,LOW(48)
	CALL SUBOPT_0x7
	__SUBD1N -2
	CALL SUBOPT_0x6
	SBIW R30,2
	SBCI R22,0
	SBCI R23,0
	CALL __GETW1PF
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x88:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x8A
	SUBI R18,-LOW(1)
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+12,R30
	STD  Y+12+1,R31
	RJMP _0x88
_0x8A:
	CPI  R18,58
	BRLO _0x8B
	SBRS R16,3
	RJMP _0x8C
	SUBI R18,-LOW(7)
	RJMP _0x8D
_0x8C:
	SUBI R18,-LOW(39)
_0x8D:
_0x8B:
	SBRC R16,4
	RJMP _0x8F
	CPI  R18,49
	BRSH _0x91
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,1
	BRNE _0x90
_0x91:
	RJMP _0xA3
_0x90:
	CP   R21,R19
	BRLO _0x95
	SBRS R16,0
	RJMP _0x96
_0x95:
	RJMP _0x94
_0x96:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x97
	LDI  R18,LOW(48)
_0xA3:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x98
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x8
	CPI  R21,0
	BREQ _0x99
	SUBI R21,LOW(1)
_0x99:
_0x98:
_0x97:
_0x8F:
	CALL SUBOPT_0x3
	CPI  R21,0
	BREQ _0x9A
	SUBI R21,LOW(1)
_0x9A:
_0x94:
	SUBI R19,LOW(1)
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,2
	BRLO _0x87
	RJMP _0x86
_0x87:
_0x84:
	SBRS R16,0
	RJMP _0x9B
_0x9C:
	CPI  R21,0
	BREQ _0x9E
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x5
	RJMP _0x9C
_0x9E:
_0x9B:
_0x9F:
_0x5E:
_0xA1:
	LDI  R17,LOW(0)
_0x49:
	RJMP _0x44
_0x46:
	CALL __LOADLOCR6
	ADIW R28,24
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETD1P
	CALL __PUTPARD1
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G2
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x0:
	CALL __PUTPARD1
	LDI  R24,0
	CALL _printf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(144)
	STS  115,R30
	LDI  R30,LOW(132)
	STS  116,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	STS  115,R30
	LDI  R30,LOW(132)
	STS  116,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x3:
	ST   -Y,R18
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x4:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	SBIW R26,4
	STD  Y+18,R26
	STD  Y+18+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5:
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6:
	__PUTD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	__GETD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8:
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
	ld   r22,y+
	ld   r23,y+
	out  rampz,r22
__strlenf0:
	elpm r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETW1PF:
	OUT  RAMPZ,R22
	ELPM R0,Z+
	ELPM R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
