// ======================= Atmega128 ؽƮ Touch α׷ ====================
//  CPU : ATmega128-16M - ؽƮ TSC2003(ġ Ʈѷ)
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#include <mega128.h>						// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <math.h>
#include <delay.h>

// Լ 
void main_menu_disp(void);						//  ޴ ǥ
int Touch_Data(int scan_time);						// ġ  
void TSC2003_Setup(void);						// I2c ʱȭ TSC2003ʱȭ
void TSC2003_Write(unsigned char  byte);				// TSC2003 ġ Write
unsigned TSC2003_Word_Read(unsigned char cmd);				// TSC2003 ġ Word Read

//  
#include "cpusetup.inc"							// cpu  ͷƮ  ƾ
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
int timer0_touch_cnt = 0;					// timer0 ġ  10ms ī

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// PortA 
// LCD_D[0..7] : LCD Data Bus
	PORTA=0xff;						// Ʈ  reg
	DDRA=0x00;                                              // Ʈ  reg(0Է,1)

// PortC 
// LCD_D[8..15] : LCD Data Bus(color lcd)
// PortC.0 : LCD_CS1
// PortC.1 : LCD_CS2
	PORTC=0xfc;						// Ʈ  reg
	DDRC=0x03;                                              // Ʈ  reg(0Է,1)

// PortE 
// PortE.3(OUT) : LCD DIR
// PortE.4(OUT) : LCD E
// PortE.5(OUT) : LCD RS
// PortE.6(OUT) : GLCD/CLCD Reset
// PortE.7(IN)  : TSC2003 Interrupt PULL UP(external)
	PORTE=0x40;						// Ʈ  reg
	DDRE=0x78;                                              // Ʈ  reg(0Է,1)

// PortG 
// PortG.0(OUT) : LCD R/W,CLCD_WR
// PortG.1(OUT) : LCD RD
// PortG.2(OUT) : LCD CS
	PORTG=0x07;						// Ʈ  reg
	DDRG=0x07;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	TCCR0 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99
	OCR0=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	ETIMSK=0x00;

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x33;

// External SRAM page configuration:
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): 1r/w
//	MCUCR=0xc0;
//	XMCRA=0x02;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

// Global enable interrupts
#asm("sei")
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [USART0_RXC] void uart0_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSR0A;
	data=UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_touch_cnt++;					// Ÿ̸0 ġ  ī++
}

//  
int Touch_X = 0,Touch_Y = 0;						// ġ ġ  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();							// cpu ʱȭ
	TSC2003_Setup();						// I2c ʱȭ TSC2003ʱȭ
	main_menu_disp();						//  ޴ ǥ
	while(1){
		if(com1_rx_eflg){					// COM1  ˻
			putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
		if(Touch_Data(2)){					// ġ  ˻ 20ms
			printf("touch > (x)%d : (y)%d\r\n",Touch_X,Touch_Y);
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("======= TSC2003 Touch Test =======\r\n");
	printf("- press any touch screen         -\r\n");
	printf("----------------------------------\r\n");
}

// ========================== ġκ ͸  =======================
// [μ] int scan_time
// Item1: ġ SCAN Timne(scan_time * 10ms)
// [] 1( ȿ),0( )
// [] Touch_X,Touch_Y : ġ  
// ---------------------------------------------------------------------------
int Touch_Data(int scan_time)
{
	if((PINE&0x80) == 0){						// ġ ?
		if(timer0_touch_cnt >= scan_time){			// ġ  üũ Ÿ scan_time*10ms
			Touch_X = TSC2003_Word_Read(0xcc);		// X  / 12bit / ADC ON
			Touch_Y = TSC2003_Word_Read(0xdc);		// Y  / 12bit / ADC ON
			TSC2003_Write(0x38);				// PENIRQ ready mode
			timer0_touch_cnt = 0;				// timer clear
			return(1);
		}
	}
	else timer0_touch_cnt = 0;					//  
	return(0);
}

// ================================ TSC2003 Setup ============================
// [μ] void
// ---------------------------------------------------------------------------
void TSC2003_Setup(void)
{
// TWI(I2c) setup
	TWBR = 0x0c;							// Bit Rate: 400.000 kHz
	TWDR = 0xff;							// TWI DATA = 0xff
	TWSR = 0x00;							//  Clear , prescaler = 00(1)

// TSC2003 setup
	TSC2003_Write(0x38);						// PENIRQ ready mode
}

// ================================ TSC2003 Write ============================
// [μ] unsigned char datau
// Item1:  
// ---------------------------------------------------------------------------
void TSC2003_Write(unsigned char datau)
{
	TWCR = 0xa4;							// START
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x08));
	TWDR = 0x90;							// Address 0 + write
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x18));
	TWDR = datau;							// data ۽
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x28));

	TWCR = 0x94;							// Ϸ 
}

// =============================== TSC2003 word Read =========================
// [μ] unsigned char cmd
// Item1: ġ  command 
// ---------------------------------------------------------------------------
unsigned TSC2003_Word_Read(unsigned char cmd)
{
unsigned char byte;
unsigned rdatau = 0;

	TWCR = 0xa4;							// START
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x08));
	TWDR = 0x90;							// Address 0 + write
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x18));
	TWDR = cmd;							// cmd data ۽
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x28));

	TWCR = 0xa4;							// START
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x10));	//  ?
	TWDR = 0x91;   							// Address 0 + read
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x40));	// SLA-R Ϸ?
	TWCR = 0xc4;							// data read
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x50));	// data  ACK?
	rdatau = TWDR;
	TWCR = 0x84;							// TWINT 1 Ἥ Ŭ
	while(((TWCR & 0x80) == 0x00) || ((TWSR & 0xf8) != 0x58));	// data  ACK?
	byte = TWDR;

	TWCR = 0x94;							// Ϸ 

	rdatau =  (rdatau << 4) & 0x0ff0;				// D11-D4
	rdatau |= (unsigned)((byte >> 4) & 0x0f);			// D3-D0

	return rdatau;
}
